import { IndexKey } from "web-utility";
export type DataObject = Record<string, any>;
export interface VNode {
    key?: IndexKey;
    text?: string;
    tagName?: string;
    props?: DataObject;
    style?: DataObject;
    children?: VNode[];
    node?: Node;
}
declare global {
    namespace JSX {
        interface IntrinsicElements extends HTMLTags {
        }
    }
}
export class DOMRenderer {
    propsMap: DataObject;
    attrsMap: any;
    eventPattern: RegExp;
    protected keyOf: ({ key, text, props }: VNode, index?: number) => any;
    protected vNodeOf: (list: VNode[], key: string) => VNode;
    protected updateProps<T extends DataObject>(node: T, oldProps?: DataObject, newProps?: DataObject, onDelete?: (node: T, key: string) => any, onAdd?: (node: T, key: string, value: any) => any): void;
    protected createNode(vNode: VNode): Node;
    protected updateChildren(node: ParentNode, oldList: VNode[], newList: VNode[]): void;
    patch(oldVNode: VNode, newVNode: VNode): VNode;
    toVNode: (node: Node) => VNode;
    render(vNode: VNode, node?: Element): VNode;
}

//# sourceMappingURL=index.d.ts.map
